
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gio.Interfaces.DesktopAppInfoLookup
    ( 

-- * Exported types
    DesktopAppInfoLookup(..)                ,
    noDesktopAppInfoLookup                  ,
    DesktopAppInfoLookupK                   ,
    toDesktopAppInfoLookup                  ,


 -- * Methods
-- ** desktopAppInfoLookupGetDefaultForUriScheme
    desktopAppInfoLookupGetDefaultForUriScheme,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gio.Types
import GI.Gio.Callbacks
import qualified GI.GObject as GObject

-- interface DesktopAppInfoLookup 

newtype DesktopAppInfoLookup = DesktopAppInfoLookup (ForeignPtr DesktopAppInfoLookup)
noDesktopAppInfoLookup :: Maybe DesktopAppInfoLookup
noDesktopAppInfoLookup = Nothing

type instance AttributeList DesktopAppInfoLookup = DesktopAppInfoLookupAttributeList
type DesktopAppInfoLookupAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList DesktopAppInfoLookup = DesktopAppInfoLookupSignalList
type DesktopAppInfoLookupSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

foreign import ccall "g_desktop_app_info_lookup_get_type"
    c_g_desktop_app_info_lookup_get_type :: IO GType

type instance ParentTypes DesktopAppInfoLookup = DesktopAppInfoLookupParentTypes
type DesktopAppInfoLookupParentTypes = '[GObject.Object]

instance GObject DesktopAppInfoLookup where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_g_desktop_app_info_lookup_get_type
    

class GObject o => DesktopAppInfoLookupK o
instance (GObject o, IsDescendantOf DesktopAppInfoLookup o) => DesktopAppInfoLookupK o

toDesktopAppInfoLookup :: DesktopAppInfoLookupK o => o -> IO DesktopAppInfoLookup
toDesktopAppInfoLookup = unsafeCastTo DesktopAppInfoLookup

-- method DesktopAppInfoLookup::get_default_for_uri_scheme
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gio" "DesktopAppInfoLookup", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "uri_scheme", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gio" "DesktopAppInfoLookup", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "uri_scheme", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gio" "AppInfo"
-- throws : False
-- Skip return : False

foreign import ccall "g_desktop_app_info_lookup_get_default_for_uri_scheme" g_desktop_app_info_lookup_get_default_for_uri_scheme :: 
    Ptr DesktopAppInfoLookup ->             -- _obj : TInterface "Gio" "DesktopAppInfoLookup"
    CString ->                              -- uri_scheme : TBasicType TUTF8
    IO (Ptr AppInfo)

{-# DEPRECATED desktopAppInfoLookupGetDefaultForUriScheme ["The #GDesktopAppInfoLookup interface is deprecated and unused by gio."]#-}
desktopAppInfoLookupGetDefaultForUriScheme ::
    (MonadIO m, DesktopAppInfoLookupK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- uri_scheme
    m AppInfo
desktopAppInfoLookupGetDefaultForUriScheme _obj uri_scheme = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    uri_scheme' <- textToCString uri_scheme
    result <- g_desktop_app_info_lookup_get_default_for_uri_scheme _obj' uri_scheme'
    checkUnexpectedReturnNULL "g_desktop_app_info_lookup_get_default_for_uri_scheme" result
    result' <- (wrapObject AppInfo) result
    touchManagedPtr _obj
    freeMem uri_scheme'
    return result'


