
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gio.Interfaces.FileDescriptorBased
    ( 

-- * Exported types
    FileDescriptorBased(..)                 ,
    noFileDescriptorBased                   ,
    FileDescriptorBasedK                    ,
    toFileDescriptorBased                   ,


 -- * Methods
-- ** fileDescriptorBasedGetFd
    fileDescriptorBasedGetFd                ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gio.Types
import GI.Gio.Callbacks
import qualified GI.GObject as GObject

-- interface FileDescriptorBased 

newtype FileDescriptorBased = FileDescriptorBased (ForeignPtr FileDescriptorBased)
noFileDescriptorBased :: Maybe FileDescriptorBased
noFileDescriptorBased = Nothing

type instance AttributeList FileDescriptorBased = FileDescriptorBasedAttributeList
type FileDescriptorBasedAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList FileDescriptorBased = FileDescriptorBasedSignalList
type FileDescriptorBasedSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

foreign import ccall "g_file_descriptor_based_get_type"
    c_g_file_descriptor_based_get_type :: IO GType

type instance ParentTypes FileDescriptorBased = FileDescriptorBasedParentTypes
type FileDescriptorBasedParentTypes = '[GObject.Object]

instance GObject FileDescriptorBased where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_g_file_descriptor_based_get_type
    

class GObject o => FileDescriptorBasedK o
instance (GObject o, IsDescendantOf FileDescriptorBased o) => FileDescriptorBasedK o

toFileDescriptorBased :: FileDescriptorBasedK o => o -> IO FileDescriptorBased
toFileDescriptorBased = unsafeCastTo FileDescriptorBased

-- method FileDescriptorBased::get_fd
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gio" "FileDescriptorBased", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gio" "FileDescriptorBased", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt32
-- throws : False
-- Skip return : False

foreign import ccall "g_file_descriptor_based_get_fd" g_file_descriptor_based_get_fd :: 
    Ptr FileDescriptorBased ->              -- _obj : TInterface "Gio" "FileDescriptorBased"
    IO Int32


fileDescriptorBasedGetFd ::
    (MonadIO m, FileDescriptorBasedK a) =>
    a ->                                    -- _obj
    m Int32
fileDescriptorBasedGetFd _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- g_file_descriptor_based_get_fd _obj'
    touchManagedPtr _obj
    return result


