
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gio.Objects
    (     module GI.Gio.Objects.AppInfoMonitor    ,
    module GI.Gio.Objects.AppLaunchContext  ,
    module GI.Gio.Objects.Application       ,
    module GI.Gio.Objects.ApplicationCommandLine,
    module GI.Gio.Objects.BufferedInputStream,
    module GI.Gio.Objects.BufferedOutputStream,
    module GI.Gio.Objects.BytesIcon         ,
    module GI.Gio.Objects.Cancellable       ,
    module GI.Gio.Objects.CharsetConverter  ,
    module GI.Gio.Objects.ConverterInputStream,
    module GI.Gio.Objects.ConverterOutputStream,
    module GI.Gio.Objects.Credentials       ,
    module GI.Gio.Objects.DBusActionGroup   ,
    module GI.Gio.Objects.DBusAuthObserver  ,
    module GI.Gio.Objects.DBusConnection    ,
    module GI.Gio.Objects.DBusInterfaceSkeleton,
    module GI.Gio.Objects.DBusMenuModel     ,
    module GI.Gio.Objects.DBusMessage       ,
    module GI.Gio.Objects.DBusMethodInvocation,
    module GI.Gio.Objects.DBusObjectManagerClient,
    module GI.Gio.Objects.DBusObjectManagerServer,
    module GI.Gio.Objects.DBusObjectProxy   ,
    module GI.Gio.Objects.DBusObjectSkeleton,
    module GI.Gio.Objects.DBusProxy         ,
    module GI.Gio.Objects.DBusServer        ,
    module GI.Gio.Objects.DataInputStream   ,
    module GI.Gio.Objects.DataOutputStream  ,
    module GI.Gio.Objects.DesktopAppInfo    ,
    module GI.Gio.Objects.Emblem            ,
    module GI.Gio.Objects.EmblemedIcon      ,
    module GI.Gio.Objects.FileEnumerator    ,
    module GI.Gio.Objects.FileIOStream      ,
    module GI.Gio.Objects.FileIcon          ,
    module GI.Gio.Objects.FileInfo          ,
    module GI.Gio.Objects.FileInputStream   ,
    module GI.Gio.Objects.FileMonitor       ,
    module GI.Gio.Objects.FileOutputStream  ,
    module GI.Gio.Objects.FilenameCompleter ,
    module GI.Gio.Objects.FilterInputStream ,
    module GI.Gio.Objects.FilterOutputStream,
    module GI.Gio.Objects.IOStream          ,
    module GI.Gio.Objects.InetAddress       ,
    module GI.Gio.Objects.InetAddressMask   ,
    module GI.Gio.Objects.InetSocketAddress ,
    module GI.Gio.Objects.InputStream       ,
    module GI.Gio.Objects.ListStore         ,
    module GI.Gio.Objects.MemoryInputStream ,
    module GI.Gio.Objects.MemoryOutputStream,
    module GI.Gio.Objects.Menu              ,
    module GI.Gio.Objects.MenuAttributeIter ,
    module GI.Gio.Objects.MenuItem          ,
    module GI.Gio.Objects.MenuLinkIter      ,
    module GI.Gio.Objects.MenuModel         ,
    module GI.Gio.Objects.MountOperation    ,
    module GI.Gio.Objects.NativeVolumeMonitor,
    module GI.Gio.Objects.NetworkAddress    ,
    module GI.Gio.Objects.NetworkService    ,
    module GI.Gio.Objects.Notification      ,
    module GI.Gio.Objects.OutputStream      ,
    module GI.Gio.Objects.Permission        ,
    module GI.Gio.Objects.PropertyAction    ,
    module GI.Gio.Objects.ProxyAddress      ,
    module GI.Gio.Objects.ProxyAddressEnumerator,
    module GI.Gio.Objects.Resolver          ,
    module GI.Gio.Objects.Settings          ,
    module GI.Gio.Objects.SimpleAction      ,
    module GI.Gio.Objects.SimpleActionGroup ,
    module GI.Gio.Objects.SimpleAsyncResult ,
    module GI.Gio.Objects.SimpleIOStream    ,
    module GI.Gio.Objects.SimplePermission  ,
    module GI.Gio.Objects.SimpleProxyResolver,
    module GI.Gio.Objects.Socket            ,
    module GI.Gio.Objects.SocketAddress     ,
    module GI.Gio.Objects.SocketAddressEnumerator,
    module GI.Gio.Objects.SocketClient      ,
    module GI.Gio.Objects.SocketConnection  ,
    module GI.Gio.Objects.SocketControlMessage,
    module GI.Gio.Objects.SocketListener    ,
    module GI.Gio.Objects.SocketService     ,
    module GI.Gio.Objects.Subprocess        ,
    module GI.Gio.Objects.SubprocessLauncher,
    module GI.Gio.Objects.Task              ,
    module GI.Gio.Objects.TcpConnection     ,
    module GI.Gio.Objects.TcpWrapperConnection,
    module GI.Gio.Objects.TestDBus          ,
    module GI.Gio.Objects.ThemedIcon        ,
    module GI.Gio.Objects.ThreadedSocketService,
    module GI.Gio.Objects.TlsCertificate    ,
    module GI.Gio.Objects.TlsConnection     ,
    module GI.Gio.Objects.TlsDatabase       ,
    module GI.Gio.Objects.TlsInteraction    ,
    module GI.Gio.Objects.TlsPassword       ,
    module GI.Gio.Objects.UnixConnection    ,
    module GI.Gio.Objects.UnixCredentialsMessage,
    module GI.Gio.Objects.UnixFDList        ,
    module GI.Gio.Objects.UnixFDMessage     ,
    module GI.Gio.Objects.UnixInputStream   ,
    module GI.Gio.Objects.UnixMountMonitor  ,
    module GI.Gio.Objects.UnixOutputStream  ,
    module GI.Gio.Objects.UnixSocketAddress ,
    module GI.Gio.Objects.Vfs               ,
    module GI.Gio.Objects.VolumeMonitor     ,
    module GI.Gio.Objects.ZlibCompressor    ,
    module GI.Gio.Objects.ZlibDecompressor  ,


    ) where

import GI.Gio.Objects.AppInfoMonitor
import GI.Gio.Objects.AppLaunchContext
import GI.Gio.Objects.Application
import GI.Gio.Objects.ApplicationCommandLine
import GI.Gio.Objects.BufferedInputStream
import GI.Gio.Objects.BufferedOutputStream
import GI.Gio.Objects.BytesIcon
import GI.Gio.Objects.Cancellable
import GI.Gio.Objects.CharsetConverter
import GI.Gio.Objects.ConverterInputStream
import GI.Gio.Objects.ConverterOutputStream
import GI.Gio.Objects.Credentials
import GI.Gio.Objects.DBusActionGroup
import GI.Gio.Objects.DBusAuthObserver
import GI.Gio.Objects.DBusConnection
import GI.Gio.Objects.DBusInterfaceSkeleton
import GI.Gio.Objects.DBusMenuModel
import GI.Gio.Objects.DBusMessage
import GI.Gio.Objects.DBusMethodInvocation
import GI.Gio.Objects.DBusObjectManagerClient
import GI.Gio.Objects.DBusObjectManagerServer
import GI.Gio.Objects.DBusObjectProxy
import GI.Gio.Objects.DBusObjectSkeleton
import GI.Gio.Objects.DBusProxy
import GI.Gio.Objects.DBusServer
import GI.Gio.Objects.DataInputStream
import GI.Gio.Objects.DataOutputStream
import GI.Gio.Objects.DesktopAppInfo
import GI.Gio.Objects.Emblem
import GI.Gio.Objects.EmblemedIcon
import GI.Gio.Objects.FileEnumerator
import GI.Gio.Objects.FileIOStream
import GI.Gio.Objects.FileIcon
import GI.Gio.Objects.FileInfo
import GI.Gio.Objects.FileInputStream
import GI.Gio.Objects.FileMonitor
import GI.Gio.Objects.FileOutputStream
import GI.Gio.Objects.FilenameCompleter
import GI.Gio.Objects.FilterInputStream
import GI.Gio.Objects.FilterOutputStream
import GI.Gio.Objects.IOStream
import GI.Gio.Objects.InetAddress
import GI.Gio.Objects.InetAddressMask
import GI.Gio.Objects.InetSocketAddress
import GI.Gio.Objects.InputStream
import GI.Gio.Objects.ListStore
import GI.Gio.Objects.MemoryInputStream
import GI.Gio.Objects.MemoryOutputStream
import GI.Gio.Objects.Menu
import GI.Gio.Objects.MenuAttributeIter
import GI.Gio.Objects.MenuItem
import GI.Gio.Objects.MenuLinkIter
import GI.Gio.Objects.MenuModel
import GI.Gio.Objects.MountOperation
import GI.Gio.Objects.NativeVolumeMonitor
import GI.Gio.Objects.NetworkAddress
import GI.Gio.Objects.NetworkService
import GI.Gio.Objects.Notification
import GI.Gio.Objects.OutputStream
import GI.Gio.Objects.Permission
import GI.Gio.Objects.PropertyAction
import GI.Gio.Objects.ProxyAddress
import GI.Gio.Objects.ProxyAddressEnumerator
import GI.Gio.Objects.Resolver
import GI.Gio.Objects.Settings
import GI.Gio.Objects.SimpleAction
import GI.Gio.Objects.SimpleActionGroup
import GI.Gio.Objects.SimpleAsyncResult
import GI.Gio.Objects.SimpleIOStream
import GI.Gio.Objects.SimplePermission
import GI.Gio.Objects.SimpleProxyResolver
import GI.Gio.Objects.Socket
import GI.Gio.Objects.SocketAddress
import GI.Gio.Objects.SocketAddressEnumerator
import GI.Gio.Objects.SocketClient
import GI.Gio.Objects.SocketConnection
import GI.Gio.Objects.SocketControlMessage
import GI.Gio.Objects.SocketListener
import GI.Gio.Objects.SocketService
import GI.Gio.Objects.Subprocess
import GI.Gio.Objects.SubprocessLauncher
import GI.Gio.Objects.Task
import GI.Gio.Objects.TcpConnection
import GI.Gio.Objects.TcpWrapperConnection
import GI.Gio.Objects.TestDBus
import GI.Gio.Objects.ThemedIcon
import GI.Gio.Objects.ThreadedSocketService
import GI.Gio.Objects.TlsCertificate
import GI.Gio.Objects.TlsConnection
import GI.Gio.Objects.TlsDatabase
import GI.Gio.Objects.TlsInteraction
import GI.Gio.Objects.TlsPassword
import GI.Gio.Objects.UnixConnection
import GI.Gio.Objects.UnixCredentialsMessage
import GI.Gio.Objects.UnixFDList
import GI.Gio.Objects.UnixFDMessage
import GI.Gio.Objects.UnixInputStream
import GI.Gio.Objects.UnixMountMonitor
import GI.Gio.Objects.UnixOutputStream
import GI.Gio.Objects.UnixSocketAddress
import GI.Gio.Objects.Vfs
import GI.Gio.Objects.VolumeMonitor
import GI.Gio.Objects.ZlibCompressor
import GI.Gio.Objects.ZlibDecompressor

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gio.Types
import GI.Gio.Callbacks


