
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gio.Objects.MenuLinkIter
    ( 

-- * Exported types
    MenuLinkIter(..)                        ,
    MenuLinkIterK                           ,
    toMenuLinkIter                          ,
    noMenuLinkIter                          ,


 -- * Methods
-- ** menuLinkIterGetName
    menuLinkIterGetName                     ,


-- ** menuLinkIterGetNext
    menuLinkIterGetNext                     ,


-- ** menuLinkIterGetValue
    menuLinkIterGetValue                    ,


-- ** menuLinkIterNext
    menuLinkIterNext                        ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gio.Types
import GI.Gio.Callbacks
import qualified GI.GObject as GObject

newtype MenuLinkIter = MenuLinkIter (ForeignPtr MenuLinkIter)
foreign import ccall "g_menu_link_iter_get_type"
    c_g_menu_link_iter_get_type :: IO GType

type instance ParentTypes MenuLinkIter = MenuLinkIterParentTypes
type MenuLinkIterParentTypes = '[GObject.Object]

instance GObject MenuLinkIter where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_g_menu_link_iter_get_type
    

class GObject o => MenuLinkIterK o
instance (GObject o, IsDescendantOf MenuLinkIter o) => MenuLinkIterK o

toMenuLinkIter :: MenuLinkIterK o => o -> IO MenuLinkIter
toMenuLinkIter = unsafeCastTo MenuLinkIter

noMenuLinkIter :: Maybe MenuLinkIter
noMenuLinkIter = Nothing

type instance AttributeList MenuLinkIter = MenuLinkIterAttributeList
type MenuLinkIterAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList MenuLinkIter = MenuLinkIterSignalList
type MenuLinkIterSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method MenuLinkIter::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gio" "MenuLinkIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gio" "MenuLinkIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "g_menu_link_iter_get_name" g_menu_link_iter_get_name :: 
    Ptr MenuLinkIter ->                     -- _obj : TInterface "Gio" "MenuLinkIter"
    IO CString


menuLinkIterGetName ::
    (MonadIO m, MenuLinkIterK a) =>
    a ->                                    -- _obj
    m T.Text
menuLinkIterGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- g_menu_link_iter_get_name _obj'
    checkUnexpectedReturnNULL "g_menu_link_iter_get_name" result
    result' <- cstringToText result
    touchManagedPtr _obj
    return result'

-- method MenuLinkIter::get_next
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gio" "MenuLinkIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "out_link", argType = TBasicType TUTF8, direction = DirectionOut, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TInterface "Gio" "MenuModel", direction = DirectionOut, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferEverything}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gio" "MenuLinkIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "g_menu_link_iter_get_next" g_menu_link_iter_get_next :: 
    Ptr MenuLinkIter ->                     -- _obj : TInterface "Gio" "MenuLinkIter"
    Ptr CString ->                          -- out_link : TBasicType TUTF8
    Ptr (Ptr MenuModel) ->                  -- value : TInterface "Gio" "MenuModel"
    IO CInt


menuLinkIterGetNext ::
    (MonadIO m, MenuLinkIterK a) =>
    a ->                                    -- _obj
    m (Bool,T.Text,MenuModel)
menuLinkIterGetNext _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    out_link <- allocMem :: IO (Ptr CString)
    value <- allocMem :: IO (Ptr (Ptr MenuModel))
    result <- g_menu_link_iter_get_next _obj' out_link value
    let result' = (/= 0) result
    out_link' <- peek out_link
    out_link'' <- cstringToText out_link'
    value' <- peek value
    value'' <- (wrapObject MenuModel) value'
    touchManagedPtr _obj
    freeMem out_link
    freeMem value
    return (result', out_link'', value'')

-- method MenuLinkIter::get_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gio" "MenuLinkIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gio" "MenuLinkIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gio" "MenuModel"
-- throws : False
-- Skip return : False

foreign import ccall "g_menu_link_iter_get_value" g_menu_link_iter_get_value :: 
    Ptr MenuLinkIter ->                     -- _obj : TInterface "Gio" "MenuLinkIter"
    IO (Ptr MenuModel)


menuLinkIterGetValue ::
    (MonadIO m, MenuLinkIterK a) =>
    a ->                                    -- _obj
    m MenuModel
menuLinkIterGetValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- g_menu_link_iter_get_value _obj'
    checkUnexpectedReturnNULL "g_menu_link_iter_get_value" result
    result' <- (wrapObject MenuModel) result
    touchManagedPtr _obj
    return result'

-- method MenuLinkIter::next
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gio" "MenuLinkIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gio" "MenuLinkIter", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "g_menu_link_iter_next" g_menu_link_iter_next :: 
    Ptr MenuLinkIter ->                     -- _obj : TInterface "Gio" "MenuLinkIter"
    IO CInt


menuLinkIterNext ::
    (MonadIO m, MenuLinkIterK a) =>
    a ->                                    -- _obj
    m Bool
menuLinkIterNext _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- g_menu_link_iter_next _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'


