
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gio.Objects.NativeVolumeMonitor
    ( 

-- * Exported types
    NativeVolumeMonitor(..)                 ,
    NativeVolumeMonitorK                    ,
    toNativeVolumeMonitor                   ,
    noNativeVolumeMonitor                   ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gio.Types
import GI.Gio.Callbacks
import qualified GI.GObject as GObject

newtype NativeVolumeMonitor = NativeVolumeMonitor (ForeignPtr NativeVolumeMonitor)
foreign import ccall "g_native_volume_monitor_get_type"
    c_g_native_volume_monitor_get_type :: IO GType

type instance ParentTypes NativeVolumeMonitor = NativeVolumeMonitorParentTypes
type NativeVolumeMonitorParentTypes = '[VolumeMonitor, GObject.Object]

instance GObject NativeVolumeMonitor where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_g_native_volume_monitor_get_type
    

class GObject o => NativeVolumeMonitorK o
instance (GObject o, IsDescendantOf NativeVolumeMonitor o) => NativeVolumeMonitorK o

toNativeVolumeMonitor :: NativeVolumeMonitorK o => o -> IO NativeVolumeMonitor
toNativeVolumeMonitor = unsafeCastTo NativeVolumeMonitor

noNativeVolumeMonitor :: Maybe NativeVolumeMonitor
noNativeVolumeMonitor = Nothing

type instance AttributeList NativeVolumeMonitor = NativeVolumeMonitorAttributeList
type NativeVolumeMonitorAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList NativeVolumeMonitor = NativeVolumeMonitorSignalList
type NativeVolumeMonitorSignalList = ('[ '("drive-changed", VolumeMonitorDriveChangedSignalInfo), '("drive-connected", VolumeMonitorDriveConnectedSignalInfo), '("drive-disconnected", VolumeMonitorDriveDisconnectedSignalInfo), '("drive-eject-button", VolumeMonitorDriveEjectButtonSignalInfo), '("drive-stop-button", VolumeMonitorDriveStopButtonSignalInfo), '("mount-added", VolumeMonitorMountAddedSignalInfo), '("mount-changed", VolumeMonitorMountChangedSignalInfo), '("mount-pre-unmount", VolumeMonitorMountPreUnmountSignalInfo), '("mount-removed", VolumeMonitorMountRemovedSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("volume-added", VolumeMonitorVolumeAddedSignalInfo), '("volume-changed", VolumeMonitorVolumeChangedSignalInfo), '("volume-removed", VolumeMonitorVolumeRemovedSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


