
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gio.Objects.SimplePermission
    ( 

-- * Exported types
    SimplePermission(..)                    ,
    SimplePermissionK                       ,
    toSimplePermission                      ,
    noSimplePermission                      ,


 -- * Methods
-- ** simplePermissionNew
    simplePermissionNew                     ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gio.Types
import GI.Gio.Callbacks
import qualified GI.GObject as GObject

newtype SimplePermission = SimplePermission (ForeignPtr SimplePermission)
foreign import ccall "g_simple_permission_get_type"
    c_g_simple_permission_get_type :: IO GType

type instance ParentTypes SimplePermission = SimplePermissionParentTypes
type SimplePermissionParentTypes = '[Permission, GObject.Object]

instance GObject SimplePermission where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_g_simple_permission_get_type
    

class GObject o => SimplePermissionK o
instance (GObject o, IsDescendantOf SimplePermission o) => SimplePermissionK o

toSimplePermission :: SimplePermissionK o => o -> IO SimplePermission
toSimplePermission = unsafeCastTo SimplePermission

noSimplePermission :: Maybe SimplePermission
noSimplePermission = Nothing

type instance AttributeList SimplePermission = SimplePermissionAttributeList
type SimplePermissionAttributeList = ('[ '("allowed", PermissionAllowedPropertyInfo), '("can-acquire", PermissionCanAcquirePropertyInfo), '("can-release", PermissionCanReleasePropertyInfo)] :: [(Symbol, *)])

type instance SignalList SimplePermission = SimplePermissionSignalList
type SimplePermissionSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method SimplePermission::new
-- method type : Constructor
-- Args : [Arg {argName = "allowed", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "allowed", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gio" "SimplePermission"
-- throws : False
-- Skip return : False

foreign import ccall "g_simple_permission_new" g_simple_permission_new :: 
    CInt ->                                 -- allowed : TBasicType TBoolean
    IO (Ptr SimplePermission)


simplePermissionNew ::
    (MonadIO m) =>
    Bool ->                                 -- allowed
    m SimplePermission
simplePermissionNew allowed = liftIO $ do
    let allowed' = (fromIntegral . fromEnum) allowed
    result <- g_simple_permission_new allowed'
    checkUnexpectedReturnNULL "g_simple_permission_new" result
    result' <- (wrapObject SimplePermission) result
    return result'


