
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gio.Objects.UnixCredentialsMessage
    ( 

-- * Exported types
    UnixCredentialsMessage(..)              ,
    UnixCredentialsMessageK                 ,
    toUnixCredentialsMessage                ,
    noUnixCredentialsMessage                ,


 -- * Methods
-- ** unixCredentialsMessageGetCredentials
    unixCredentialsMessageGetCredentials    ,


-- ** unixCredentialsMessageIsSupported
    unixCredentialsMessageIsSupported       ,


-- ** unixCredentialsMessageNew
    unixCredentialsMessageNew               ,


-- ** unixCredentialsMessageNewWithCredentials
    unixCredentialsMessageNewWithCredentials,




 -- * Properties
-- ** Credentials
    UnixCredentialsMessageCredentialsPropertyInfo,
    constructUnixCredentialsMessageCredentials,
    getUnixCredentialsMessageCredentials    ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gio.Types
import GI.Gio.Callbacks
import qualified GI.GObject as GObject

newtype UnixCredentialsMessage = UnixCredentialsMessage (ForeignPtr UnixCredentialsMessage)
foreign import ccall "g_unix_credentials_message_get_type"
    c_g_unix_credentials_message_get_type :: IO GType

type instance ParentTypes UnixCredentialsMessage = UnixCredentialsMessageParentTypes
type UnixCredentialsMessageParentTypes = '[SocketControlMessage, GObject.Object]

instance GObject UnixCredentialsMessage where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_g_unix_credentials_message_get_type
    

class GObject o => UnixCredentialsMessageK o
instance (GObject o, IsDescendantOf UnixCredentialsMessage o) => UnixCredentialsMessageK o

toUnixCredentialsMessage :: UnixCredentialsMessageK o => o -> IO UnixCredentialsMessage
toUnixCredentialsMessage = unsafeCastTo UnixCredentialsMessage

noUnixCredentialsMessage :: Maybe UnixCredentialsMessage
noUnixCredentialsMessage = Nothing

-- VVV Prop "credentials"
   -- Type: TInterface "Gio" "Credentials"
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getUnixCredentialsMessageCredentials :: (MonadIO m, UnixCredentialsMessageK o) => o -> m Credentials
getUnixCredentialsMessageCredentials obj = liftIO $ getObjectPropertyObject obj "credentials" Credentials

constructUnixCredentialsMessageCredentials :: (CredentialsK a) => a -> IO ([Char], GValue)
constructUnixCredentialsMessageCredentials val = constructObjectPropertyObject "credentials" val

data UnixCredentialsMessageCredentialsPropertyInfo
instance AttrInfo UnixCredentialsMessageCredentialsPropertyInfo where
    type AttrAllowedOps UnixCredentialsMessageCredentialsPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint UnixCredentialsMessageCredentialsPropertyInfo = CredentialsK
    type AttrBaseTypeConstraint UnixCredentialsMessageCredentialsPropertyInfo = UnixCredentialsMessageK
    type AttrGetType UnixCredentialsMessageCredentialsPropertyInfo = Credentials
    type AttrLabel UnixCredentialsMessageCredentialsPropertyInfo = "UnixCredentialsMessage::credentials"
    attrGet _ = getUnixCredentialsMessageCredentials
    attrSet _ = undefined
    attrConstruct _ = constructUnixCredentialsMessageCredentials

type instance AttributeList UnixCredentialsMessage = UnixCredentialsMessageAttributeList
type UnixCredentialsMessageAttributeList = ('[ '("credentials", UnixCredentialsMessageCredentialsPropertyInfo)] :: [(Symbol, *)])

type instance SignalList UnixCredentialsMessage = UnixCredentialsMessageSignalList
type UnixCredentialsMessageSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method UnixCredentialsMessage::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TInterface "Gio" "UnixCredentialsMessage"
-- throws : False
-- Skip return : False

foreign import ccall "g_unix_credentials_message_new" g_unix_credentials_message_new :: 
    IO (Ptr UnixCredentialsMessage)


unixCredentialsMessageNew ::
    (MonadIO m) =>
    m UnixCredentialsMessage
unixCredentialsMessageNew  = liftIO $ do
    result <- g_unix_credentials_message_new
    checkUnexpectedReturnNULL "g_unix_credentials_message_new" result
    result' <- (wrapObject UnixCredentialsMessage) result
    return result'

-- method UnixCredentialsMessage::new_with_credentials
-- method type : Constructor
-- Args : [Arg {argName = "credentials", argType = TInterface "Gio" "Credentials", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "credentials", argType = TInterface "Gio" "Credentials", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gio" "UnixCredentialsMessage"
-- throws : False
-- Skip return : False

foreign import ccall "g_unix_credentials_message_new_with_credentials" g_unix_credentials_message_new_with_credentials :: 
    Ptr Credentials ->                      -- credentials : TInterface "Gio" "Credentials"
    IO (Ptr UnixCredentialsMessage)


unixCredentialsMessageNewWithCredentials ::
    (MonadIO m, CredentialsK a) =>
    a ->                                    -- credentials
    m UnixCredentialsMessage
unixCredentialsMessageNewWithCredentials credentials = liftIO $ do
    let credentials' = unsafeManagedPtrCastPtr credentials
    result <- g_unix_credentials_message_new_with_credentials credentials'
    checkUnexpectedReturnNULL "g_unix_credentials_message_new_with_credentials" result
    result' <- (wrapObject UnixCredentialsMessage) result
    touchManagedPtr credentials
    return result'

-- method UnixCredentialsMessage::get_credentials
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Gio" "UnixCredentialsMessage", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Gio" "UnixCredentialsMessage", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gio" "Credentials"
-- throws : False
-- Skip return : False

foreign import ccall "g_unix_credentials_message_get_credentials" g_unix_credentials_message_get_credentials :: 
    Ptr UnixCredentialsMessage ->           -- _obj : TInterface "Gio" "UnixCredentialsMessage"
    IO (Ptr Credentials)


unixCredentialsMessageGetCredentials ::
    (MonadIO m, UnixCredentialsMessageK a) =>
    a ->                                    -- _obj
    m Credentials
unixCredentialsMessageGetCredentials _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- g_unix_credentials_message_get_credentials _obj'
    checkUnexpectedReturnNULL "g_unix_credentials_message_get_credentials" result
    result' <- (newObject Credentials) result
    touchManagedPtr _obj
    return result'

-- method UnixCredentialsMessage::is_supported
-- method type : MemberFunction
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "g_unix_credentials_message_is_supported" g_unix_credentials_message_is_supported :: 
    IO CInt


unixCredentialsMessageIsSupported ::
    (MonadIO m) =>
    m Bool
unixCredentialsMessageIsSupported  = liftIO $ do
    result <- g_unix_credentials_message_is_supported
    let result' = (/= 0) result
    return result'


